#include <iostream>
#include <stdio.h>
#include <algorithm>
#define SIZE 75001
using namespace std;
long long int NZD(long long int a, long long int b)
{
    if (a == 0)
       return b;
    if (b == 0)
       return a;
    if (a == b)
        return a;
    if (a > b)
        return NZD(a%b, b);
    else
        return NZD(a, b%a);
}

long long int nzd(long long int a[], int n)
{
    if (n == 2)
        return abs(a[0]-a[1]);
    long long b = NZD(abs(a[0] - a[1]), abs(a[1] - a[2]));
    for(int i = 3; i < n; i ++)
    {
        b = NZD(b, abs(a[i] - a[i-1]));
        if(b == 1)
            return 1;
    }
    return b;
}


int main()
{
    int t;
    int n, m;
    long long lcd;
    int tt[5];
    long long a[SIZE], b[SIZE];
    scanf("%d", &t);
    for(int T = 0; T < t; T ++)
    {
        tt[T] = 1;
        scanf("%d %d", &n, &m);
        for(int i = 0; i < n; i ++)
        {
            scanf("%l64d", &a[i]);
        }
        for(int i = 0; i < m; i ++)
        {
            scanf("%l64d", &b[i]);
        }
        lcd = nzd(a, n);
        for(int i = 0; (i < m) && tt[t]; i ++)
        {
            if(abs(b[i]-a[0]) % lcd == 0)
            {
                tt[T] = 0;
            }
        }
    }
    for(int i = 0; i < t; i ++)
    {
        printf("%d\n", tt[i]);
    }
    return 0;
}